package org.bdware.consistency.plugin.raft.algo.message;

import org.bdware.sc.conn.ByteUtil;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;

public class RequestVoteResponse implements IRaftMessage {
    RaftMessageType type;
    long term;
    boolean granted;

    public RequestVoteResponse() {
        type = RaftMessageType.RequestVoteResponse;
    }

    public RequestVoteResponse(long term, boolean granted) {
        type = RaftMessageType.RequestVoteResponse;
        this.term = term;
        this.granted = granted;
    }

    @Override
    public byte[] getBytes() {
        ByteArrayOutputStream msg = new ByteArrayOutputStream();
        ByteUtil.writeLong(msg, term);
        ByteUtil.writeBoolean(msg, granted);
        return msg.toByteArray();
    }

    @Override
    public IRaftMessage parse(byte[] b) {
        RequestVoteResponse msg = new RequestVoteResponse();
        ByteArrayInputStream bi = new ByteArrayInputStream(b);
        msg.term = ByteUtil.readLong(bi);
        msg.granted = ByteUtil.readBoolean(bi);
        return msg;
    }

    @Override
    public RaftMessageType getType() {
        return type;
    }

    public void setType(RaftMessageType type) {
        this.type = type;
    }

    public long getTerm() {
        return term;
    }

    public void setTerm(long term) {
        this.term = term;
    }

    public boolean isGranted() {
        return granted;
    }

    public void setGranted(boolean granted) {
        this.granted = granted;
    }
}
