package org.bdware.consistency.plugin.ro;

import com.google.gson.JsonObject;
import com.google.gson.JsonParser;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.bdware.consistency.plugin.common.AbstractContextContractExecutor;
import org.bdware.sc.bean.ContractRequest;
import org.bdware.sc.conn.OnHashCallback;
import org.bdware.sc.conn.ResultCallback;
import org.bdware.sc.util.JsonUtil;

import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.atomic.AtomicInteger;

public class RequestOnceExecutor extends AbstractContextContractExecutor {
    private static final Logger LOGGER = LogManager.getLogger(RequestOnceExecutor.class);
    String contractID;
    AtomicInteger order = new AtomicInteger(0);

    public RequestOnceExecutor(String contractID) {
        this.contractID = contractID;
    }

    @Override
    public void execute(String requestID, ContractRequest req, ResultCallback rc, OnHashCallback hcb) {
        ResultCallback cb =
                new ResultCallback() {
                    @Override
                    public void onResult(String str) {
                        LOGGER.debug(str);
                        JsonObject jo = JsonParser.parseString(str).getAsJsonObject();
                        JsonObject result =
                                JsonParser.parseString(jo.get("data").getAsString())
                                        .getAsJsonObject();
                        for (String key : result.keySet()) jo.add(key, result.get(key));
                        jo.remove("action");
                        jo.addProperty("action", "onExecuteResult");
                        LOGGER.debug(jo.toString());
                        rc.onResult(jo.toString());
                    }
                };
        masterServerTCPAction.getSync().sleep(requestID, cb);
        String[] members = cmActions.getManager().multiContractRecorder.getMultiContractMeta(contractID).getMembers();
        for (int i = 0; i < members.length; i++) {
            LOGGER.info("[members]:" + members.length);
            int size = members.length;
            String nodeID = members[order.incrementAndGet() % size];
            //ADD Connect
            Map<String, Object> obj = new HashMap<>();
            obj.put("action", "executeContractLocally");
            obj.put("requestID", requestID);
            obj.put("data", req);
            obj.put("uniReqID", requestID);
            networkManager.sendToAgent(nodeID, JsonUtil.toJson(obj));
            return;
        }
        rc.onResult(
                "{\"status\":\"Error\",\"result\":\"all nodes "
                        + " offline\",\"action\":\"onExecuteContract\"}");
    }
}
