package org.bdware.consistency.plugin.single;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.bdware.sdk.consistency.api.ContractExecutorFactory;
import org.bdware.server.trustedmodel.ContractExecutor;
import org.bdware.server.trustedmodel.SingleNodeExecutor;

import java.util.Map;

public class SingleNodeExecutorFactory implements ContractExecutorFactory {
    private static final Logger LOGGER = LogManager.getLogger(SingleNodeExecutorFactory.class);

    @Override
    public String getExecutorName() {
        return "Sole";
    }

    @Override
    public ContractExecutor getInstance(Map<String, Object> args) {
        LOGGER.info("Sole contract is not supported in multi-point mode");
        return SingleNodeExecutor.instance;
    }
}
